#!/bin/sh 
# (C)GPL 26 feb 2005 georgeskesseler(a)yahoo.com
version="0.11"

# this script uses index files to cut a .ts stream into pieces
# it is programmed so it can run on any linux, *including* the dreambox itself
# it is *very slow* on a dreambox, be patient

# install on dreambox:
# copy as "cutmovie.sh" into /var/bin/ directory
# cd /var/bin
# chmod 755 cutmovie.sh

# create index files with the remote control: push "shift"-"green" to set
# an index mark. it shows in the bar graph as a red line
# to delete an index, jump to it (shift red or shift blue, then immediately press shift green)

# to cut a movie into pieces:
# cutmovie.sh "/hdd/movie/My Favorite Movie.ts"
#
# the parts end up in a subdirectory "My Favorite Movie"
# You can access them vie the root menu (red button, /hdd, movie)

# problem: what is the real blocksize???
blocksize=188  # TS packet size
# dreambox stores in  10 TS packets chunks, one TS packet is normed to be 188 bytes

if [ "$1" = "" ]
then
  echo $0 version $version
  echo usage: $0 moviename.ts.indexmarks [moviename.ts.indexmarks ...]
  echo return code 0 if successful
  exit
fi

. /var/bin/moviebouquet.sh

mydd()
{
  # mydd infile outfile start188block end188block
  metablock=42
  # the metablock value is established by try and error
  #  1 = 0.5MB/s
  # 25 = 1.8MB/s
  # 42 = 2.4MB/s (the answer to Life, the Universe and Everything)
  # 64 = 1.9MB/s
  #128 = 0.5MB/s
  # well seems that system block is 8K, 8192/188=43, well ok, but I like 42!
  infile="$1"; outfile="$2"; startblock="$3"; endblock="$4";
  if [ "$endblock" = "" ]
  then
    dd if="$infile" bs=$((blocksize*metablock)) skip=$((startblock/metablock))|
    (dd bs=$blocksize of=/dev/null count=$((startblock-(startblock/metablock*metablock)));
     dd bs=$blocksize)|
    dd bs=$((blocksize*metablock)) of="$outfile"
  else
    dd if="$infile" bs=$((blocksize*metablock)) skip=$((startblock/metablock))|
    (dd bs=$blocksize of=/dev/null count=$((startblock-(startblock/metablock*metablock)));
     dd bs=$blocksize count=$((endblock-startblock)))|
    dd bs=$((blocksize*metablock)) of="$outfile" 
  fi
}

#if ! hdparm -C /dev/ide/host0/bus0/target0/lun0/disc |grep active
#then
#  echo "harddisk not active, doing nothing"
#  exit 1
#fi
if [ -f "/tmp/finalcut.pid" ]
then
  otherPID=$(cat /tmp/finalcut.pid)
  if [ $(ps -edf|grep $otherPID|grep -v grep|wc -l) -gt 0 ]
  then
    echo "already running"
    exit 1
  fi
fi
echo $$ > /tmp/finalcut.pid

cd /hdd/movie

while [ "$1" != "" ]
do
  echo "$1"
  shift
done | while read m 
do
pwd="$(pwd)"
dir="${m%/*}"
if [ "$dir" != "$m" ]
then
  cd "$dir"
fi 
m="${m##*/}"
m="${m%%.indexmarks}"
movie_ts="$(basename "$m")"
movie_eit="${movie_ts%%.ts}.eit"
movie_idx="$movie_ts.indexmarks"
movie_dir="${movie_ts%%.ts}"
movie_out=" ${movie_ts%%.ts}"

if [ ! -f "$movie_idx" ]
then
  echo "no index file for $movie_ts"
  continue
fi  

outbouquet=$(initbouquet "${movie_ts%%.ts}")

# cleanup bouquet...
while getservice "$outbouquet" 1
do
  delservice "$outbouquet"
done 
# cleanup destintation dir
rm "$movie_dir/"*


set dummy $(ls -el "$movie_ts")

length=$6

cutin=0
cutout=0
cutaccu=0
offset=0
part="001"
sub=""
mkdir "$movie_dir" 2>/dev/null
cp -p "$movie_eit" "$movie_dir/$movie_eit"
cp -p "$movie_ts.indexmarks" "$movie_dir/$movie_ts.indexmarks"
> "$movie_dir/delete me after editing.mpg" 
FILE="$movie_dir/delete me after editing.mpg"
DESCRIPTION="delete this line after editing"
SERVICE=""
addservice "$outbouquet"

# initialize value for PUSI
# the trick is: shell does no know binary. So we just say that if something in the header changes
# then that is the start indicator
i=100;
PUSI="";hflag1="";hflag2=""
hf1=0;hf2=0;
while [ "$PUSI" = "" ] && [ $i -lt 300 ]
do
  headerflag=$(dd if="$movie_ts" bs=188 skip=$i count=1 2>/dev/null|dd bs=2 count=1 2>/dev/null)
  if [ "$hflag1" = "" ] 
  then
    hflag1="$headerflag" 
  else
    if [ "$hflag2" = "" ] && [ "$hflag1" != "$headerflag" ]
    then
      hflag2="$headerflag"
    fi
  fi  
  [ "$hflag1" = "$headerflag" ] && hf1=$((hf1+1))
  [ "$hflag2" = "$headerflag" ] && hf2=$((hf2+1))
  [ $hf1 -gt $((hf2+10)) ] && PUSI="$hflag2"
  [ $hf2 -gt $((hf1+10)) ] && PUSI="$hflag1"
  i=$((i+1))
done 
if [ "$PUSI" = "" ]
then
  echo "WARNING: bad TS, cutpoints will not be aligned"
fi 

if [ "$ODD" = "" ]
then
  SAVER="13579"
fi
if [ "$EVEN" = "" ]
then
  SAVER="${SAVER}02468"
fi
SAVER="[$SAVER]"


while read mark1 mark2
do
  cutout=$((mark1*10))   # multiply by 10, coz dreambox stores in chunks of 10 TS blocks
  again="yes"
  while [ "$again" = "yes" ]
  do
    echo "cut '$movie_ts$s$sub' from $((cutin-cutaccu)) ($(((cutin-cutaccu)*blocksize))) to $((cutout-cutaccu)) ($(((cutout-cutaccu)*blocksize))) -> ${part}${movie_out}.ts$cs$csub"

    if [ "${part%$SAVER}" = "${part}" ]
    then
      echo "skipping $part"
    else
      mydd "$movie_ts$s$sub" "${movie_dir}/${part}${movie_out}.ts$cs$csub" $((cutin-cutaccu)) $((cutout-cutaccu))
    fi
    if [ "$((cutout-cutaccu))" -gt $((length/blocksize)) ]
    then   # this may fail if cutin is exactly on a ts file end, tough luck!
      cutaccu=$((cutaccu+(length/blocksize)))
      s="."
      cs="."
      sub=$(echo $sub|sed 's/^00*//')
      sub=$((sub+1))
      sub=$(echo $sub | sed 's/^\(.\)$/00\1/
                             s/^\(..\)$/0\1/')
      csub=$(echo $csub|sed 's/^00*//')
      csub=$((csub+1))
      csub=$(echo $csub | sed 's/^\(.\)$/00\1/
                             s/^\(..\)$/0\1/')
                             
      cutin=$cutaccu
      if [ -f "$movie_ts$s$sub" ]
      then
        set dummy $(ls -el "$movie_ts$s$sub")
        length=$6
      else
        exit 0 
      fi 
    else
      again="no"
    fi                           
  done
 
  # we wrote an end of a part, check if we have an end of PES, that means is the next TS a begin of PES?
  # if no PES begin found, loop until we get one
  # offset calculation
  offset=0
  if [ "$PUSI" != "" ]
  then
    dd if="$movie_ts$s$sub" of="${movie_dir}/$$PES.ts" bs=$blocksize skip=$((cutout-cutaccu)) count=100 2>/dev/null 
    echo "searching PUSI (payload start indicator)"
    while [ "$offset" -lt 1000 ]
    do
      if [ "$(dd if="${movie_dir}/$$PES.ts" bs=1 count=2 skip=$((188*$offset)) 2>/dev/null)" = "$PUSI" ]
      then
        break
      fi
      offset=$((offset+1))
    done
    # put rest until next PES into previous part
    if [ "${part%$SAVER}" = "${part}" ]
    then
      echo "skipping PES for $part"
    else
      echo "adding $offset $((offset*blocksize)) "
      dd if="${movie_dir}/$$PES.ts" bs=$blocksize count=$offset >> "${movie_dir}/${part}${movie_out}.ts$cs$csub"
    fi
    rm "${movie_dir}/$$PES.ts"
  fi  
  cutin=$cutout+$offset
  
  FILE="${movie_dir}/${part}${movie_out}.ts"
  DESCRIPTION="part $part"
  SERVICE=""
  if [ "${part%$SAVER}" = "${part}" ]
  then
    echo "skipping part $part"
  else
    addservice "$outbouquet"
  fi
  
  part=$(echo $part|sed 's/^00*//')
  part=$((part+1))
  part=$(echo $part | sed 's/^\(.\)$/00\1/
                           s/^\(..\)$/0\1/')

  cs=""
  csub=""                           
done < "$movie_idx"
while [ -f "$movie_ts$s$sub" ]
do
  # dd if="$movie_ts$s$sub" of="${movie_dir}/${part}${movie_out}.ts$cs$csub" bs=$blocksize skip=$((cutin-cutaccu)) 
  echo "cut '$movie_ts$s$sub' from $((cutin-cutaccu)) ($(((cutin-cutaccu)*blocksize))) to 'the end' -> ${part}${movie_out}.ts$cs$csub"
  if [ "${part%$SAVER}" = "${part}" ]
  then
    echo "skipping $part"
  else
    mydd "$movie_ts$s$sub" "${movie_dir}/${part}${movie_out}.ts$cs$csub" $((cutin-cutaccu)) 
  fi
  cutin=0
  cutaccu=0
  s="."
  cs="."
  sub=$(echo $sub|sed 's/^00*//')
  sub=$((sub+1))
  sub=$(echo $sub | sed 's/^\(.\)$/00\1/
                         s/^\(..\)$/0\1/')
  csub=$(echo $csub|sed 's/^00*//')
  csub=$((csub+1))
  csub=$(echo $csub | sed 's/^\(.\)$/00\1/
                           s/^\(..\)$/0\1/')
done
FILE="${movie_dir}/${part}${movie_out}.ts"
DESCRIPTION="part $part"
SERVICE=""
if [ "${part%$SAVER}" = "${part}" ]
then
  echo "skipping part $part"
else
  addservice "$outbouquet"
fi 

cd "$pwd"

done
exit 0
