#!/bin/sh
# (C)GPL 27 feb 2005 georgeskesseler (a) yahoo.com
# put into regular cron
# this searches cut movies and replaces the original ones with the cut version

blocksmax=500000
blocksize=1880

if [ -f "/tmp/finalcut.pid" ]
then
  otherPID=$(cat /tmp/finalcut.pid)
  if [ $(ps -edf|grep $otherPID|grep -v grep|wc -l) -gt 0 ]
  then
    echo "already running"
    exit
  fi 
fi 
echo $$ > /tmp/finalcut.pid

. /var/bin/moviebouquet.sh

listbouquets | while read bouquet
do
  if [ -d "/hdd/movie/$bouquet" ]
  then
    echo "$bouquet"
  fi
done |
while read movie
do
#  if hdparm -C /dev/ide/host0/bus0/target0/lun0/disc |grep active
#  then
    cd /hdd/movie
#  else
#    echo "harddisk is not running, doing nothing"
#    exit
#  fi
  MovBouquet=$(initbouquet "$movie")
  if grep -q "delete me after editing.mpg" "$MovBouquet"
  # if [ -f "$movie/delete me after editing.mpg" ]
  then
    continue
  fi
  rm "$movie/delete me after editing.mpg"
  echo "treating $movie"
  sub=""
  s=""
  movie=$(echo "$movie"|sed 's/\/$//')
  cd "$movie"
  if [ $? -ne 0 ]
  then
    echo "ERROR, cannot cd into movie dir: $movie"
    continue
  fi
  rm "cannot finalize, indexes changed.mpg" 2>/dev/null
  if [ ! -f "${movie}.ts.indexmarks" ] || [ "../${movie}.ts.indexmarks" -nt "${movie}.ts.indexmarks" ]
  then
    echo "since cutting, new indexmarks were added, doing nothing"
    > "cannot finalize, indexes changed.mpg"
    > "delete me after editing.mpg"
    FILE="$(pwd)/delete me after editing.mpg"
    DESCRIPTION="delete this line after editing"
    SERVICE=""
    addservice "$MovBouquet" 1
    cd ..
    continue
  fi
  rm "cannot finalize, eit changed.mpg" 2>/dev/null
  if [ -f "../${movie}.eit" ] && ( [ ! -f "${movie}.eit" ] || [ "../${movie}.eit" -nt "${movie}.eit" ] )
  then
    echo "since cutting, the eit info has changed. Doing nothing"
    > "cannot finalize, eit changed.mpg"
    > "delete me after editing.mpg"
    FILE="$(pwd)/delete me after editing.mpg"
    DESCRIPTION="delete this line after editing"
    SERVICE=""
    addservice "$MovBouquet" 1
    cd ..
    continue
  fi
  if ! getservice "$MovBouquet" 1
  # if [ "$(ls | grep "^[0-9][0-9][0-9] ")" = "" ]
  then
    echo "no part files to join"
    rm "${movie}.ts.indexmarks"
    rm "${movie}.eit"
    rm *"$movie.ts" *"$movie.ts."*
    cd ..
    rmdir "${movie}"
    delservice "$MovBouquet"
    continue
  fi
  
  # this is the end!!!
  echo "deleting original $movie"
  rm "../$movie.ts"
  rm "../$movie.ts".*
  echo "recreating info files for $movie"
  mv "${movie}.ts.indexmarks" "../${movie}.ts.indexmarks"
  mv "${movie}.eit" "../${movie}.eit"
  > "../${movie}.ts.indexmarks"
  indexmark=0
  while getservice "$MovBouquet" 1
  # ls | grep "^[0-9][0-9][0-9] " | while read part
  do
    if [ $indexmark -gt 0 ]
    then
      echo "$indexmark $((indexmark/253))" >> "../${movie}.ts.indexmarks"
    fi
    part="$FILE"
    cs=""
    csub=""
    while [ -f "$part$cs$csub" ]
    do
      echo "merging part: $part$cs$csub"
      set dummy $(ls -el "$part$cs$csub")
      sourcelen=$6
      sourcelen=$((sourcelen/blocksize))
      saved=0
             
      while [ "$saved" -lt "$sourcelen" ]
      do
        if [ -f "../${movie}.ts$s$sub" ]
        then
          set dummy $(ls -el "../${movie}.ts$s$sub")
          before=$6
#          indexmark=$((indexmark+before/1880))
          before=$((before/blocksize))
#          echo "$indexmark $((indexmark/253))" >> "../${movie}.ts.indexmarks"
        else
          before=0
        fi
        dd if="$part$cs$csub" bs=$blocksize skip=$saved count=$((blocksmax-before)) >> "../${movie}.ts$s$sub"
        set dummy $(ls -el "../${movie}.ts$s$sub")
        after=$6
        after=$((after/blocksize))
        
        saved=$((saved+after-before))
        
        if [ "$after" -ge "$blocksmax" ]
        then
          s="."
          sub=$(echo $sub|sed 's/^00*//')
          sub=$((sub+1))
          sub=$(echo $sub | sed 's/^\(.\)$/00\1/
                                 s/^\(..\)$/0\1/')
        fi
      done  # lt
      rm "$part$cs$csub"
      indexmark=$((indexmark+saved))
      cs="."
      csub=$(echo $csub|sed 's/^00*//')
      csub=$((csub+1))
      csub=$(echo $csub | sed 's/^\(.\)$/00\1/
                               s/^\(..\)$/0\1/')
    done # -f
    delservice "$MovBouquet"
  done  # part                           
  rm *"$movie.ts" *"$movie.ts."*
  cd ..
  if rmdir "$movie" 
  then
    delbouquet "$MovBouquet"
  else
    echo "ERROR cleaning up!"
    > "$movie/delete me after editing.mpg"
    FILE="$(pwd)/delete me after editing.mpg"
    DESCRIPTION="delete this line after editing"
    SERVICE=""
    addservice "$MovBouquet" 1
  fi
done # ls
             
